#ifndef CFCGI_LIB_COOKIE_H
#define CFCGI_LIB_COOKIE_H
#include <string>
#include <map>
#include <iostream>
#include <vector>

using KeyValueType = std::map<std::string, std::string>;

struct FcgiCookieItem {
    std::string m_domain;
    std::string m_path;
    std::string m_expires;
    bool m_httpOnly;
    KeyValueType m_keyValues;
};
std::ostream& operator<<(std::ostream& oss,const FcgiCookieItem& ci);
std::istream& operator>>(std::istream& iss, FcgiCookieItem& ci);

class FcgiCookie {
    using CookiePool = std::vector<FcgiCookieItem>;
public:
    FcgiCookie();
    ~FcgiCookie();
public:
    // APIs
    const std::string& Get(const std::string& name, const std::string& dft = "");
    void Set(const std::string& cookie, const std::string& expires = "",
             const std::string& domain = "", const std::string& path = "/",
             const bool& httponly = true);
    void Set(const std::vector<std::string>& names, const std::vector<std::string>& values,
             const std::string& expires = "", const std::string& domain = "",
             const std::string& path = "/", const bool& httponly = true);
public:
    void parseCookie(const std::string& cookies);
    bool empty();
    void toString(std::string& dest);
    void toString(std::ostream& dest);
private:
    CookiePool m_cookies;
};

#endif
