#ifndef CFCGI_LIB_FORM_DATA_H
#define CFCGI_LIB_FORM_DATA_H
#include <string>
#include <vector>
#include <fstream>

class FileChunk {
public:
    FileChunk();
    ~FileChunk();

    std::string     m_fileName;
    std::string     m_contentType;
    std::fstream    m_tmpFile;
    std::string     m_name;
    std::string     m_filePath;

    bool            m_complete;
    std::string     m_boundary;
};
// multipart/formdata; file upload

class FormData {
public:
    FormData(const std::string& tmpdir = "", const std::string& boundary = "");
    ~FormData();

    // API methods
    std::vector<FileChunk*> Files();

    // for coroutine
    void parseData(const std::string&& Data);
    void SetBoundary(const std::string& boundary);
    void SetTempDir(const std::string& tmpdir);

private:
    bool writeFile(std::fstream& f, const std::string& data,
                   std::string::size_type& pos, const std::string& end);
private:
    int             m_chunkCount;
    std::vector<FileChunk*> m_files;
    std::string     m_boundary;
    std::string     m_tmpdir;
};
#endif // CFCGI_FORM_DATA_H
