#ifndef CFCGI_LIB_RESPONSE_H
#define CFCGI_LIB_RESPONSE_H

#include <string>
#include <sstream>
#include <map>
#include "cfcgi_cookie.h"

class FcgiResponse {
public:
    using ParamType = std::map<std::string, std::string>;
    FcgiResponse();
    ~FcgiResponse();

    void Header(const std::string& name, const std::string& value);
    std::string Header(const std::string& name);
    FcgiCookie& Cookie();
    ParamType& Headers();

    void header2Str(std::string& dest);
    void header2Str(std::ostream& oss);
public:
    std::stringstream Out;
    std::stringstream Err;

    bool m_headerSended;
private:
    ParamType m_headers;
    FcgiCookie m_cookies;
};

#endif
