#ifndef CFCGI_LIB_SESSION_H
#define CFCGI_LIB_SESSION_H

#include "cfcgi_object.h"
#include <time.h>

#define MAX_SESSION_IN_CACHE 500

class FcgiSession : public FcgiObject {
public:
    FcgiSession(const std::string& sid = "", const std::string& sessdir = "");
    virtual ~FcgiSession();
    const std::string& GetID();
    bool Start(const std::string& sessid = "");
    void Destroy();
    void SetExpires(int expire = 0);

    friend std::ofstream& operator<<(std::ofstream& o, const FcgiSession& v);
    friend std::ifstream& operator>>(std::ifstream& o, FcgiSession& v);

    void Save();
private:
    void generateID();
    bool checkExpired();
private:
    std::string     m_id;
    std::string     m_path;
    std::string     m_file;
    time_t          m_expires;
};

#endif // CFCGI_LIB_SESSION_H
