#ifndef CFCGI_LIB_XML_H
#define CFCGI_LIB_XML_H
#include <vector>
#include <list>
#include <string>
#include <iostream>

struct XmlAttr {
    std::string name;
    std::string value;
};

struct XmlAttrVec {
    std::vector<XmlAttr> m_attr;

    std::string& operator[](const std::string& name);
};

class FcgiXml {
public:
    typedef typename std::list<FcgiXml>::iterator dataiter;

    operator std::string() const;
    FcgiXml& operator[](const std::string& name);
    FcgiXml& operator=(const std::string& s);

    friend std::ostream& operator<<(std::ostream& o, const FcgiXml& x);
    friend std::istream& operator>>(std::istream& o, FcgiXml& x);
    friend bool operator<(const FcgiXml& lh, const FcgiXml& rh);
private:
    dataiter findLoc(const std::string& name);
public:
    XmlAttrVec  attr;
private:
    XmlAttr     data;
    std::list<FcgiXml> children;
};

extern std::string NullString;
extern FcgiXml     NullXmlNode;

#endif // CFCGI_LIB_XML_H
